#include <ntddk.H>

#ifndef _SAMPLE_
#define _SAMPLE_

#define POOL_TAG 'HAJE'

typedef struct _DEVICE_EXTENSION 
{
	PDEVICE_OBJECT PhysicalDeviceObject; /* physical device object */
	PDEVICE_OBJECT NextLayerDeviceObject; /* Next Layer device object */
	PDEVICE_OBJECT DeviceObject; /* Self device object */

	IO_REMOVE_LOCK					RemoveLock;

	DEVICE_CAPABILITIES DeviceCaps;	
	SYSTEM_POWER_STATE DevicePowerState;
	DEVICE_POWER_STATE SystemPowerState;

}DEVICE_EXTENSION, *PDEVICE_EXTENSION;

NTSTATUS
SAMPLE_AddDevice
	(
	IN PDRIVER_OBJECT DriverObject,         
	IN PDEVICE_OBJECT PhysicalDeviceObject  
	);

VOID                                                                
SAMPLE_Unload                                                       
	(                                                               
	IN PDRIVER_OBJECT DriverObject  /* pointer to device object */
	);

NTSTATUS
SAMPLE_DeferIrpCompletion
	(
	IN PDEVICE_OBJECT DeviceObject,     /* pointer to a device object */
	IN PIRP Irp,                        /* pointer to a I/O request packet */
	IN PVOID Context                    /* driver defined context */
	);

NTSTATUS
SAMPLE_PnpDispatch
	(
	IN PDEVICE_OBJECT DeviceObject,     /* pointer to device object */
	IN PIRP Irp                         /* pointer to an I/O request packet */
	);

NTSTATUS
SAMPLE_PowerDispatch
	(
	IN PDEVICE_OBJECT DeviceObject,     /* pointer to device object */
	IN PIRP Irp                         /* pointer to an I/O request packet */
	);

#endif //_SAMPLE_
