#include <wdm.h>
#include <ntddk.h>
#include <ntddmou.h>

#define UNICODE_DEVICE_NAME		L"\\Device\\MouseFilterTest"
#define UNICODE_SYMBOL_NAME		L"\\DosDevices\\MouseFilterTest"

#define IOCTL_FILTER_START		CTL_CODE(FILE_DEVICE_UNKNOWN, 0x0801, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_FILTER_STOP		CTL_CODE(FILE_DEVICE_UNKNOWN, 0x0802, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_EVENT_ADDR		CTL_CODE(FILE_DEVICE_UNKNOWN, 0x0803, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_INTERNAL_MOUSE_CONNECT    CTL_CODE(FILE_DEVICE_MOUSE, 0x0080, METHOD_NEITHER, FILE_ANY_ACCESS)

NTSTATUS DriverEntry							( PDRIVER_OBJECT, PUNICODE_STRING );
NTSTATUS FilterAddRoutine						( PDRIVER_OBJECT, PDEVICE_OBJECT );
NTSTATUS FilterUnloadRoutine					( PDRIVER_OBJECT );
NTSTATUS FilterDispatch							( PDEVICE_OBJECT, PIRP );
NTSTATUS FilterPnPRoutine						( PDEVICE_OBJECT, PIRP );
NTSTATUS FilterDeviceIoControlRoutine			( PDEVICE_OBJECT, PIRP );
NTSTATUS FilterInternalDeviceIoControlRoutine	( PDEVICE_OBJECT, PIRP );
NTSTATUS FilterPowerRoutine						( PDEVICE_OBJECT, PIRP );

typedef
VOID
(*PSERVICE_CALLBACK_ROUTINE) (
    IN PVOID NormalContext,
    IN PVOID SystemArgument1,
    IN PVOID SystemArgument2,
    IN OUT PVOID SystemArgument3
    );

typedef struct _CONNECT_DATA {
    IN PDEVICE_OBJECT ClassDeviceObject;
    IN PVOID ClassService;
} CONNECT_DATA, *PCONNECT_DATA;

typedef struct _MOUSEFILTEREXTENSION
{
	BOOLEAN					bIsFilterDeviceObject;
	union{
		PDEVICE_OBJECT			pFilterDeviceObject;			
		PDEVICE_OBJECT			pCustomDeviceObject;			
	}u;

	// FilterDeviceObject ǹ̸  
	//
	PDEVICE_OBJECT			pTopLevelOBJ;			
    PDEVICE_OBJECT			Self;
	BOOLEAN					bMouseBlock;	
	PKEVENT					pUserEvent;	
    CONNECT_DATA			UpperConnectData;
}MOUSEFILTEREXTENSION, *PMOUSEFILTEREXTENSION;
